-- Copyright 2014-2016 by Adin Hunter Baber, all rights reserved
local PlusMinusButton = ClarityLib:NewLib("Clarity4_1.Buttons.PlusMinus", 1)
if not PlusMinusButton then return end
-- lua api
local pairs = pairs
-- blizzard api
-- libs
-- add on api
-- local name space
-- locals
local Public = {}
local Scripts = {}


function PlusMinusButton.Attach(button)
    for k,v in pairs(Public) do
        button[k] = v
    end

    for k,v in pairs(Scripts) do
        button:SetScript(k, v)
    end

    button:MakePlus()
end


-- copies the state / appearance
function Public.Copy(self, from)
    if from.__state then
        self:MakePlus()
    else
        self:MakeMinus()
    end
    return self
end


function Public.MakePlus(self)
    self:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up")
    self:SetPushedTexture("Interface\\Buttons\\UI-PlusButton-Down")
    self:SetDisabledTexture("Interface\\Buttons\\UI-PlusButton-Disabled")
    self.__state = true
    return self
end


function Public.MakeMinus(self)
    self:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up")
    self:SetPushedTexture("Interface\\Buttons\\UI-MinusButton-Down")
    self:SetDisabledTexture("Interface\\Buttons\\UI-MinusButton-Disabled")
    self.__state = false
    return self
end


function Public.Toggle(self)
    if self.__state then
        self:MakeMinus()
    else
        self:MakePlus()
    end
    return self
end


-- this will cause the button to toggle whenever any mouse click occurs on it
-- thais can be limited by restricting the mouse clicks that work with the button
function Scripts.OnClick(self, mouseButton, isDown)
    self:Toggle()
    PlaySound("igMainMenuOptionCheckBoxOn")
end
