-- Copyright 2014-2016 by Adin Hunter Baber, all rights reserved
local CommandLine = ClarityLib:NewLib("Clarity4_1.Meta.CommandLine", 1)
if not CommandLine then return end
-- lua api
local unpack = unpack or table.unpack
-- blizzard api
-- libs
-- locals
local Private = {}


function CommandLine.Execute(commandList, commandMessage)
    local command, args = Private.Split(commandMessage)
    local commandProcessed = false
    if commandList[command] then
        commandProcessed = commandList[command](unpack(args))
    elseif commandList.default then
        commandProcessed = commandList.default(command)
    end

    return commandProcessed
end


function Private.Split(commandMessage)
    commandMessage = (commandMessage or ""):lower()
    local splitter = commandMessage:gmatch("[^ ]+")
    local command = splitter()
    local args = {}
    for arg in splitter do
        args[#args+1] = arg
    end
    return command, args
end
