-- Copyright 2014-2016 by Adin Hunter Baber, all rights reserved
local Localization = ClarityLib:NewLib("ClarityLib4_1.Meta.Localization", 1)
local AddOnName, AddOn = ...
if not Localization then
    Localization = ClarityLib:GetLib("ClarityLib4_1.Meta.Localization")
    AddOn.Localization = Localization.CreateLocalizationMaster()
    return
end


local LocalizationMeta = {}
LocalizationMeta.__index = LocalizationMeta


function LocalizationMeta.__call(self, code, isDefault)
    if code == nil then
        -- I cannot decide if it is ironic or not that the error messages
        -- inside of the localization lib are not localized
        return self.Lexicon or error("no localization has been set")
    elseif isDefault then -- default flag overrides code so that it works regardless of active language
        if self.Default then
            error("default localization already exists")
        else
            self.Default = {}
            if self.Lexicon then -- primary already specified
                self.Default.__index = self.Default
                setmetatable(self.Lexicon, self.Default)
            else -- the default is the localization until the actual one is set
                self.Lexicon = self.Default
                self.Code = code
            end
            return self.Default
        end
    elseif code == GetLocale() then
        self.Lexicon = {}
        self.Code = code
        if self.Default then
            self.Default.__index = self.Default
            setmetatable(self.Lexicon, self.Default)
        end
        return self.Lexicon
    else
        return nil
    end
end


function Localization.CreateLocalizationMaster()
    return setmetatable({}, LocalizationMeta)
end

AddOn.Localization = Localization.CreateLocalizationMaster()
