-- Copyright 2014-2016 by Adin Hunter Baber, all rights reserved
local _, DataDump = ...
-- lua api
-- blizzard api
-- libs
local CommandLine = ClarityLib:GetLib("Clarity4_1.Meta.CommandLine")
-- add on api
local EventWatcher = DataDump.NameSpace("EventWatcher")
local FrameDisplay = DataDump.NameSpace("FrameDisplay", "Display")
local VarDisplay = DataDump.NameSpace("VarDisplay", "Display")
-- local name space
-- locals
local CommandList = {}
local HelpList = {}


SLASH_DATADUMP1 = "/dd"
SlashCmdList["DATADUMP"] = function(commandMessage)
    CommandLine.Execute(CommandList, commandMessage)
end


HelpList[#HelpList+1] = "Data Dump commands"
HelpList[#HelpList+1] = "    /dd events new    creates a new event watcher displays"
HelpList[#HelpList+1] = "    /dd events show   shows all existing event watcher displays"
HelpList[#HelpList+1] = "    /dd events hide   hide all existing event watcher displays"
function CommandList.events(arg1)
    if arg1 == "show" then
        EventWatcher.ShowAll()
        return true
    elseif arg1 == "hide" then
        EventWatcher.HideAll()
        return true
    elseif arg1 == "new" then
        EventWatcher.Create():Show()
        return true
    end
    return false
end


HelpList[#HelpList+1] = "    /dd ui new    creates a new UIObject display"
HelpList[#HelpList+1] = "    /dd ui show   show all existing UIObject displays"
HelpList[#HelpList+1] = "    /dd ui hide   hide all existing UIObject displays"
function CommandList.ui(arg1)
    if arg1 == "show" then
        FrameDisplay.Manager:ShowAll(true)
        return true
    elseif arg1 == "hide" then
        FrameDisplay.Manager:HideAll()
        return true
    elseif arg1 == "new" then
        FrameDisplay.Manager:GetDisplay():Show()
        return true
    end
    return false
end


HelpList[#HelpList+1] = "    /dd var new    creates a new variable display"
HelpList[#HelpList+1] = "    /dd var show   show all existing variable displays"
HelpList[#HelpList+1] = "    /dd var hide   hide all existing variable displays"
function CommandList.var(arg1)
    if arg1 == "show" then
        VarDisplay.Manager:ShowAll(true)
        return true
    elseif arg1 == "hide" then
        VarDisplay.Manager:HideAll()
        return true
    elseif arg1 == "new" then
        VarDisplay.Manager:GetDisplay():Show()
        return true
    end
    return false
end


HelpList[#HelpList+1] = "    /dd help    list all data dump commands"
function CommandList.help()
    for index,helpLine in ipairs(HelpList) do
        DEFAULT_CHAT_FRAME:AddMessage(helpLine)
    end
    return true
end
CommandList.default = CommandList.help


HelpList[#HelpList+1] = "    /dd hide    hides all frames"
function CommandList.hide()
    VarDisplay.Manager:HideAll()
    FrameDisplay.Manager:HideAll()
    EventWatcher.HideAll()
end


HelpList[#HelpList+1] = "    /dd show    show all frames"
function CommandList.show()
    VarDisplay.Manager:ShowAll(true)
    FrameDisplay.Manager:ShowAll(true)
    EventWatcher.ShowAll()
end
