-- Copyright 2014-2016 by Adin Hunter Baber, all rights reserved
local _, DataDump = ...
-- lua api
-- blizzard api
-- libs
-- add on api
local FrameDisplay = DataDump.NameSpace("FrameDisplay", "Display")
local VarDisplay = DataDump.NameSpace("VarDisplay", "Display")
-- local name space
-- locals
local EventFrame = CreateFrame("Frame", "DataDumpEvents")
local Events = {}
local PlayerHasEnteredWorld = false


function Events.PLAYER_ENTERING_WORLD(...)
    if not PlayerHasEnteredWorld then
        PlayerHasEnteredWorld = true
        DEFAULT_CHAT_FRAME:AddMessage("Data Dump Loaded; /dd help for more info")
        VarDisplay.Manager:ShowAll()
        FrameDisplay.Manager:ShowAll()
    end
end


local function OnEvent(self, event, ...)
    if Events[event] then
        Events[event](...)
    end
end


EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
EventFrame:SetScript("OnEvent", OnEvent)
