-- Copyright 2014-2016 by Adin Hunter Baber, all rights reserved
local _, DataDump = ...
-- lua api
local Max = math.max
local Min = math.min
local Time = time
-- blizzard api
-- libs
-- add on api
-- local name space
local EventTracker = DataDump.NameSpace("EventWatcher", "EventTracker")
-- locals
local Public = {}
Public.__index = Public


function EventTracker.Create(eventName)
    local eventTracker =
    {
        Event = eventName,
        History = {},
        Count = 0,
        IsShown = true
    }

    return setmetatable(eventTracker, Public)
end


function Public.AddLine(self, timeStamp, ...)
    timeStamp = timeStamp or Time()
    local args = nil
    if select('#', ...) > 0 then
        args = { ... }
    end
    local historyLine =
    {
        Event = self.Event,
        TimeStamp = timeStamp,
        Args = args
    }
    self.Count = self.Count + 1
    self.History[self.Count] = historyLine
    self.Last = historyLine
    return historyLine
end
